﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Domain
{
    public class Contact
    {
        // this field is shared between all instances of this class
        private static int _id;

        public Contact(Person person, ContactType contactType)
        {
            if (person == null)
            {
                throw new ArgumentException($"{nameof(person)} has to be assigned!");
            }

            if (contactType == null)
            {
                throw new ArgumentException($"{nameof(contactType)} has to be assigned");
            }

            _id++;
            ContactId = _id;

            Person = person;
            Person.Contacts.Add(this);

            ContactType = contactType;
            ContactType.Contacts.Add(this);
        }


        public int ContactId { get; }

        public string ContactValue { get; set; }

        public Person Person { get; set; }


        public ContactType ContactType { get; set; }

        public override string ToString()
        {
            return
                $"{ContactId} - {ContactValue} belongs to " +
                $"{(Person == null ? "no one" : Person.FirstLastName)} and is of type " +
                $"{(ContactType == null ? "none" : ContactType.ContactTypeValue)}";
        }
    }
}
